;================================================================
;
; Linked list  - basic implementation
; Linked array - unsorted version
;
; Nmeth Gbor 2006.11.
;
;================================================================

IFNDEF LINKED_LIB

	LINKED_LIB EQU <LINKED_LIBRARY>

;	include \masm32\include\debug.inc
;	include \masm32\include\masm32.inc
;	includelib \masm32\lib\debug.lib
;	includelib \masm32\lib\masm32.lib

;==============================
; STRUCTURES
;
LINKED_MEMBER	STRUCT

		lpNextLink		dd ?
		lpPrevLink		dd ?
		dwSize			dd ?

LINKED_MEMBER	ENDS

LINKED_userData	EQU sizeof LINKED_MEMBER

LINKED_LIST	STRUCT

		hHeap			dd ?
		dwLength		dd ?
		lpHead			dd ?
		lpTail			dd ?

LINKED_LIST	ENDS

LINKED_ARRAY	STRUCT

				LINKED_LIST <>
		dwElementCount	dd ?
		dwElementSize	dd ?
		dwSubArraySize	dd ?
		dwSubArrayLen	dd ?
		dwFreeSlots	dd ?

LINKED_ARRAY	ENDS

LINKED_SUBARRAY	STRUCT

		lpNextLink		dd ?
		lpPrevLink		dd ?

LINKED_SUBARRAY ENDS

;==============================
; METHODS

;================================================================
; lpLList LLIST_init(lpLList,dwIniSize) - create a new linked list
;
; Paramters
;	lpLList		pointer to allocated space
;	dwIniSize	initial size of list
;
; Returns
;	lpLList		pointer to LINKED_LIST object
;
;================================================================
	LLIST_init	PROTO lpLList:DWORD,dwIniSize:DWORD
	
;================================================================
; lpLINKED LLIST_create(dwIniSize) - create a new linked list
;
; Paramters
;	dwIniSize	size of heap at the beginning
;
; Returns
;	lpLList		pointer to LINKED_LIST object
;
; 1. Allocate space for list object, create private heap
; 2. Initialize list object
;
;================================================================
	LLIST_create	PROTO dwIniSize:DWORD

;================================================================
; void LLIST_deinit(lpLList) - deinitialize a linked list object
;
; Paramters
;	lpLList		pointer to LINKED_LIST object
;
; Returns
;	none
;
;================================================================
	LLIST_deinit	PROTO lpLList:DWORD

;================================================================
; void LLIST_destroy(lpLList) - destroy a linked list object
;
; Paramters
;	lpLList		pointer to LINKED_LIST object
;
; Returns
;	none
;
;================================================================
	LLIST_destroy	PROTO lpLList:DWORD

;================================================================
; lpMember LLIST_insert(lpLList,dwIndex,dwSize) - insert a linked list member
;
; Paramters
;	lpLList		pointer to LINKED_LIST object
;	dwIndex		index of new member
;			if zero, linked to the head
;			if -1, linked to the end
;	dwSize		size of new member in bytes
; Returns
;	lpMember	pointer to new list member object's user data
;			NULL when error
;
;================================================================
	LLIST_insert	PROTO lpLList:DWORD,dwIndex:DWORD,dwSize:DWORD

;================================================================
; void LLIST_remove(lpLList,dwIndex,lpMember) - remove a linked list member
;
; Paramters
;	lpLList		pointer to LINKED_LIST object
;	dwIndex		index of member
;	lpMember	pointer of member
;
; Returns
;	none
;
;================================================================
	LLIST_remove	PROTO lpLList:DWORD,dwIndex:DWORD,lpMember:DWORD

;================================================================
; mixed LLIST_retrieve(lpLList,dwIndex,lpMember) - look for a linked list member
;
; Paramters
;	lpLList		pointer to LINKED_LIST object
;	dwIndex		index of member
;	lpMember	pointer of member
;
; Returns
;	lpMember	pointer to list member object if lpMember argument was NULL
;	dwIndex		index to list member object if lpMember argument was supplied
;	NULL		if not found
;
;================================================================
	LLIST_retrieve	PROTO lpLList:DWORD,dwIndex:DWORD,lpMember:DWORD





;================================================================
; lpLArray LARRAY_init(lpLArray,deElementSize,dwSubArrayLength) - initialize a new linked array
;
; Paramters
;	lpLArray	pointer to allocated space
;	deElementSize	size of one stored element in bytes
;	dwSubArrayLen	count of elements in one subarray
;
; Returns
;	none
;
;================================================================
	LARRAY_init	PROTO lpLArray:DWORD,deElementSize:DWORD,dwSubArrayLen:DWORD

;================================================================
; lpLArray LARRAY_create(dwElementSize,dwSubArrayLength) - create a new linked array
;
; Paramters
;	dwElementSize	size of one stored element in bytes
;	dwSubArrayLen	count of elements in one subarray
;
; Returns
;	lpLArray	pointer to LINKED_ARRAY object
;
;================================================================
	LARRAY_create	PROTO dwElementSize:DWORD,dwSubArrayLen:DWORD

;================================================================
; void LARRAY_deinit(lpLArray) - deinitialize a linked array object
;
; Paramters
;	lpLArray	pointer to allocated space
;	deElementSize	size of one stored element in bytes
;	dwSubArrayLen	count of elements in one subarray
;
; Returns
;	none
;
;================================================================
	LARRAY_deinit	TEXTEQU <LLIST_deinit>
	;LARRAY_deinit	PROTO :DWORD

;================================================================
; void LARRAY_destroy(lpLArray) - deistroy a linked array object
;
; Paramters
;	lpLArray	pointer to allocated space
;	deElementSize	size of one stored element in bytes
;	dwSubArrayLen	count of elements in one subarray
;
; Returns
;	none
;
;================================================================
	LARRAY_destroy	TEXTEQU <LLIST_destroy>
	;LARRAY_destroy	PROTO :DWORD


;================================================================
; lpVoid LARRAY_insert(lpLArray) - get next free linked array entry
;
; Paramters
;	lpLArray	pointer to LINKED_ARRAY object
; Returns
;	lpVoid		pointer to new array element
;			NULL when error
;
;================================================================
	LARRAY_insert	PROTO lpLArray:DWORD

;================================================================
; dwMoved LARRAY_remove(lpLArray,dwIndex,lpElement) - remove a linked array element
;
; Paramters
;	lpLArray	pointer to LINKED_ARRAY object
;	dwIndex		index of element
;	lpElement	pointer to element
;
; Returns
;	dwMoved		index of moved element
;
;================================================================
	LARRAY_remove	PROTO lpLArray:DWORD,dwIndex:DWORD,lpElement:DWORD

;================================================================
; mixed LARRAY_retrieve(lpLArray,dwIndex) - look for a linked array element
;
; Paramters
;	lpLArray	pointer to LINKED_ARRAY object
;	dwIndex		index of requested member
;	lpElement	pointer of requested member
;
; Returns
;	lpElement	pointer to array element object if lpElement argument was NULL
;	dwIndex		index to array element object if lpElement argument was supplied
;	NULL		if not found
;
;================================================================
	LARRAY_retrieve	PROTO lpLArray:DWORD,dwIndex:DWORD,lpElement:DWORD


ENDIF
