; 

 .586
 .model flat, stdcall
 option casemap :none

 include \masm32\include\windows.inc
 include \masm32\include\masm32.inc
 include \masm32\include\user32.inc
 include \masm32\include\kernel32.inc

 includelib \masm32\lib\masm32.lib
 includelib \masm32\lib\user32.lib
 includelib \masm32\lib\kernel32.lib

 include resource.inc
 include linked.inc
 includelib linked.lib

 include \masm32\include\debug.inc
 includelib \masm32\lib\debug.lib

 include \masm32\macros\timers.asm

	RunTest			PROTO

	DialogProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD
	
MEMBER	STRUCT
	szLabel	db 4 dup (?)
	dwData1	dd ?
	dwData2	dd ?
	dwData3	dd ?

MEMBER	ENDS


	DEF_MEMBER_COUNT	EQU   10
	DEF_ARRAY_LENGTH	EQU    8
	DEF_ELEMENT_SIZE	EQU   16
	DEF_MIN_SIZE		EQU   64
	DEF_MAX_SIZE		EQU  256
	SHOWN_ENTRIES		EQU    8

.data ; 

	dwMemberCount		dd DEF_MEMBER_COUNT
	dwSubArrayLen		dd DEF_ARRAY_LENGTH
	dwElementSize		dd DEF_ELEMENT_SIZE
	dwMinSize		dd DEF_MIN_SIZE
	dwMaxSize		dd DEF_MAX_SIZE
	bDetails		dd 0

	sTextList		db 'list',0
	sTextArray		db 'array',0

	sStartText		db 'Linked %s tests...',0Dh,0Ah,0
	sEndText		db 'Test finished.',0Dh,0Ah,0Dh,0Ah,0

	sInsertText		db ' 1.Insert',0Dh,0Ah,0
	sInsertText2		db '    insert at %ld/%lXh with size %ld bytes.',0Dh,0Ah,0
	sCountText		db ' 2.Count of members(with sentinels): %ld',0Dh,0Ah,0
	sRandText		db ' 3.Random access',0Dh,0Ah,0
	sRetrieveText		db '    %ld. retrieved member %ld/%lXh',0Dh,0Ah,0
	sRemoveText		db ' 4.Remove',0Dh,0Ah,0

	sTimeText		db '    time: %ld',0Dh,0Ah,0

.data? ; 

	lpMyList		dd ?
	lpTextBuffer		dd ?

	dwMode			dd ?

	hInstance		dd ?
	hDlgMain		dd ?
	hEditLog		dd ?

.code ; 

 include functions.inc

start:
	invoke GetModuleHandle,NULL
	mov	hInstance,eax
	invoke DialogBoxParam,eax,IDD_MAIN,NULL,offset DialogProc,NULL
	invoke ExitProcess,NULL

DialogProc	PROC hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

		mov	eax,uMsg
@WM_INITDIALOG:
		cmp	eax,WM_INITDIALOG
		jnz @WM_COMMAND
			invoke	GlobalAlloc,GPTR,128
			mov	lpTextBuffer,eax
		
			mov	eax,hDlg
			mov	hDlgMain,eax
			invoke LoadIcon,NULL,IDI_ASTERISK
			invoke SendMessage,hDlgMain,WM_SETICON,ICON_SMALL,eax
			invoke GetDlgItem,hDlgMain,IDE_LOG
			mov	hEditLog,eax
			invoke SetDlgItemInt,hDlg,IDE_MEMBERCOUNT,dwMemberCount,FALSE
			invoke SetDlgItemInt,hDlg,IDE_MINSIZE,dwMinSize,FALSE
			invoke SetDlgItemInt,hDlg,IDE_MAXSIZE,dwMaxSize,FALSE
			invoke SetDlgItemInt,hDlg,IDE_SUBARRAYLEN,dwSubArrayLen,FALSE
			invoke SetDlgItemInt,hDlg,IDE_ELEMENTSIZE,dwElementSize,FALSE
			invoke CheckRadioButton,hDlg,IDC_HEAD,IDC_RND,IDC_HEAD
			invoke CheckDlgButton,hDlg,IDC_LIST,BST_CHECKED
			invoke CheckDlgButton,hDlg,IDC_DETAILS,BST_CHECKED
			;mov	eax,1
			jmp @DialogEnd
		; ================================
@WM_COMMAND:
		cmp	eax,WM_COMMAND
		jnz @WM_CLOSE
			mov	ecx,DWORD PTR [wParam+2]
			mov	eax,wParam
			and	ecx,0FFFFh			; notification code
			and	eax,0FFFFh			; control item

			cmp	ecx,BN_CLICKED
			jnz @DialogDefault
				cmp	eax,IDB_RUN
				jnz @IDC_LIST
					call RunTests
					mov	eax,1
					jmp @DialogEnd
			@IDC_LIST:
				cmp	eax,IDC_LIST
				jnz @IDC_ARRAY
					invoke IsDlgButtonChecked,hDlgMain,IDC_ARRAY
					cmp	eax,BST_CHECKED
					jz @F
					invoke CheckDlgButton,hDlgMain,IDC_LIST,BST_CHECKED
					jmp @DialogEnd
				@@:
					invoke IsDlgButtonChecked,hDlgMain,IDC_LIST
					push	eax
					push	eax
					push	eax
					push	eax
					push	eax
					push	eax
					push	eax
					invoke GetDlgItem,hDlgMain,IDC_HEAD
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDC_TAIL
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDC_RND
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDS_SIZE1
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDE_MINSIZE
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDS_SIZE2
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDE_MAXSIZE
					push	eax
					call EnableWindow
					jmp @DialogEnd
			@IDC_ARRAY:
				cmp	eax,IDC_ARRAY
				jnz @DialogDefault
					invoke IsDlgButtonChecked,hDlgMain,IDC_LIST
					cmp	eax,BST_CHECKED
					jz @F
					invoke CheckDlgButton,hDlgMain,IDC_ARRAY,BST_CHECKED
					jmp @DialogEnd
				@@:
					invoke IsDlgButtonChecked,hDlgMain,IDC_ARRAY
					push	eax
					push	eax
					invoke GetDlgItem,hDlgMain,IDE_SUBARRAYLEN
					push	eax
					call EnableWindow
					invoke GetDlgItem,hDlgMain,IDE_ELEMENTSIZE
					push	eax
					call EnableWindow
					jmp @DialogEnd
@WM_CLOSE:	; ================================
		cmp	eax,WM_CLOSE
		jnz @DialogDefault
			invoke EndDialog,hDlgMain,NULL
			mov	eax,1
			jmp @DialogEnd
@DialogDefault:
		xor	eax,eax
@DialogEnd:
		ret
DialogProc	ENDP

end start